/// <reference types="node" />
/** /BodyParser
 *
 * @author Alex Malotky
 */
import { IncomingMessage } from "http";
export type BodyData = Map<string, string>;
type RawBodyData = Map<string, string | Blob>;
/** Clean Body Data
 *
 * @param {RawBodyData} data
 * @returns {Promise<BodyData>}
 */
export declare function cleanBodyData(data: RawBodyData | Error): Promise<BodyData | Error>;
export default function BodyParser(request: IncomingMessage | Request): Promise<BodyData | Error>;
export {};
