/// <reference types="node" />
/// <reference types="node" />
/** Engine/Context/ProtoResponse
 *
 */
import { ServerResponse } from "node:http";
import { Transform, TransformCallback } from "node:stream";
export type { ServerResponse as NodeResponse };
export default class OutgoingResponse extends Transform {
    #private;
    private working;
    private static encoder;
    /** Stringify Encoded Data
     *
     * @param {any} data
     * @param {string} encode
     * @returns {string}
     */
    private static _stringify;
    /** Text Encoder
     *
     * @param {any} data
     * @param {string} encode
     * @returns {Uint8Array}
     */
    private static _text;
    /** Proto Response Constructor
     *
     */
    constructor(response?: ServerResponse);
    /** Transform Data Override
     *
     * @param {any} data
     * @param {string} encode
     * @param {Function} callback
     */
    _transform(data: any, encode: string, callback: TransformCallback): void;
    /** Flush Override
     *
     * @param callback
     */
    _flush(callback: TransformCallback): void;
    /** Has Commited
     *
     * @returns
     */
    commited(): boolean;
    /** Status Getter
     *
     */
    get status(): number;
    /** Status Setter
     *
     */
    set status(value: number);
    /** Headers Getter
     *
     */
    get headers(): Map<string, string>;
    /** Flush Response
     *
     * @returns {Promise<Response>}
     */
    flush(): Promise<Response | undefined>;
    /** Redirect Resposne
     *
     * @param {URL} url
     * @param {number} status
     */
    redirect(url: URL, status?: number): void;
}
