/** /Engine/Routing/Layer.ts
 *
 * @author Alex Malotky
 */
import Context from "../Context";
import { PathToRegexpOptions } from "path-to-regexp";
export type Middleware = (context: Context) => Promise<void> | void;
export default class Layer {
    private _shortcut;
    private _handler;
    private _regex;
    private _keys;
    private _path;
    private _prefix;
    private _opts;
    constructor(middleware: Middleware);
    constructor(path: string, middleware: Middleware);
    constructor(path: string, opts: PathToRegexpOptions, middleware: Middleware);
    handle(context: Context): Promise<void>;
    protected match(context: Context): boolean;
    get path(): string;
    set path(value: string);
    prefix(value: string): void;
    update(value: PathToRegexpOptions): void;
}
