/** /Engine/Routing
 *
 * @author Alex Malotky
 */
import Context from "../Context";
import Router from "./Router";
type Handler = (context: Context) => Promise<void> | void;
type ErrorHandler = (error: any, context: Context) => Promise<void> | void;
export default class Routing extends Router {
    private notFoundHandler;
    private errorHandler;
    /** Routing Constructor
     *
     */
    constructor();
    /** Routing Wrappper
     *
     * @param {Context} context
     * @param {any} error
     * @returns {Promise<Response>}
     */
    route(context: Context, error?: any): Promise<Response | undefined>;
    /** Handle Routing
     *
     * @param {Context} context
     * @returns {Promise<void>}
     */
    handle(context: Context): Promise<void>;
    /** Not Found Handler Setter
     *
     * @param {Handler} handler
     */
    notFound(handler: Handler): void;
    /** Error Handler Setter
     *
     * @param {ErrorHandler} handler
     */
    error(handler: ErrorHandler): void;
}
export {};
