"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Util_1 = require("./Util");
const MimeTypes_1 = __importDefault(require("./MimeTypes"));
const Layer_1 = __importDefault(require("./Routing/Layer"));
const Util_2 = require("./Util");
function Static(route, dir) {
    const fs = (0, Util_1.nodeImport)("fs");
    const path = (0, Util_1.nodeImport)("node:path");
    function pipeWrappper(file, response) {
        return new Promise((res) => {
            fs.createReadStream(file)
                .pipe(response)
                .on("close", res);
        });
    }
    return new Layer_1.default((0, Util_2.joinPath)(route, "/*query"), { end: false }, async function handleStaticFile(ctx) {
        if (ctx.method !== "GET" && ctx.method !== "HEAD") {
            return;
        }
        const target = path.join(dir, ctx.params.get("query"));
        if (fs.existsSync(target) === false) {
            return;
        }
        const stats = fs.statSync(target);
        if (stats.isDirectory()) {
            return;
        }
        ctx.response.headers.set('Content-Type', (0, MimeTypes_1.default)(target));
        ctx.response.headers.set("Content-Length", stats.size.toString());
        ctx.response.headers.set('Content-Security-Policy', "default-src 'none'");
        ctx.response.headers.set('X-Content-Type-Options', "nosniff");
        await pipeWrappper(target, ctx.response);
        ctx.end();
    });
}
exports.default = Static;
