/// <reference types="./global.d.ts" />
/** /Engine
 *
 * @author Alex Malotky
 */
import Routing from "./Routing";
import Layer from "./Routing/Layer";
import Context, { NodeRequeset, NodeResponse } from "./Context";
import View, { RenderUpdate } from "./View";
import { Middleware } from "./Routing/Layer";
import Authorization from "./Authorization";
import RenderEnvironment from "./View/RenderEnvironment";
import Router from "./Routing/Router";
import { createElement } from "./View/Html/Element";
import Content from "./View/Html/Content";
import HttpError from "./HttpError";
export { Router, Context, createElement, HttpError, View, Authorization };
export type { Content, Middleware, RenderEnvironment, RenderUpdate };
export default class Engine extends Routing {
    private _view;
    private _auth;
    private _env;
    constructor();
    /** View Setter
     *
     * @param {View} value
     */
    view(value: View): void;
    /** Auth Setter
     *
     * @param {View} value
     */
    auth(value: Authorization): void;
    env(key: string, value: any): void;
    fetch(req: Request, env: Env): Promise<Response>;
    get server(): (req: NodeRequeset, res: NodeResponse) => Promise<Response | undefined>;
    private start;
    use(handler: Middleware | Layer): void;
    use(path: string, endpoint: Middleware | Layer): void;
}
